/*******************************************************************************
  MPLAB Harmony Application Source File
  
  Company:
    Microchip Technology Inc.
  
  File Name:
    app.c

  Summary:
    This file contains the source code for the MPLAB Harmony application.

  Description:
    This file contains the source code for the MPLAB Harmony application.  It 
    implements the logic of the application's state machine and it may call 
    API routines of other MPLAB Harmony modules in the system, such as drivers,
    system services, and middleware.  However, it does not call any of the
    system interfaces (such as the "Initialize" and "Tasks" functions) of any of
    the modules in the system or make any assumptions about when those functions
    are called.  That is the responsibility of the configuration-specific system
    files.
 *******************************************************************************/

// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2013-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/
// DOM-IGNORE-END


// *****************************************************************************
// *****************************************************************************
// Section: Included Files 
// *****************************************************************************
// *****************************************************************************


#include "app.h"

#include "stdio.h"


APP_DATA appData;
int delay_Clock = 200000000;   //VXeNbNF200MHz
char Buf[64];
int preAdcValue;    //Oi500msecO)ɌoADϊl
//Mp
char Japan[] = "Japan";
char America[] = "America";
char UK[] = "U.K.";
char France[] = "France";

//ԐMp 
char Tokyo[] = "Tokyo";         
char Washington[] = "Washington";
char London[] = "London";
char Paris[] = "Paris";
char Pardon[] = "Pardon ?";

extern char Data[128];      //RN4020Mf[^obt@[  // UARTM荞݃f[^
extern int Flag_Sw;         //SW4(on mikroBUS ]{[h)XCb`@ON/OFFԃtO
extern int Flag_centData;   //Zg̃R}hf[^MtO


void delay_us(volatile unsigned int usec)        //1secx
{
        volatile  int count;

        count = (int)(delay_Clock/20000000)*usec;
        do      //@at@200MH (Clock=200000000)
        {       //delay_us(1000)F1000.4sec  delay_us(100)F100.6sec  delay_us(10):10.5sec@@delay_us(1)F1.5sec
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");asm("NOP");
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");

                count--;
        }while(count != 0);
}



void delay_ms(volatile unsigned int msec)        //1msecx
{
        volatile unsigned int i;         //Fat200MH (Clock=200000000)//delay_ms(1)F 1.0006msec   delay_ms(100)F100.04msec

        for(i=0; i<msec; i++)
        delay_us(1000);
}



void Write_Byte(char chr)  //1oCgM֐    //RN4020p
{
//    PLIB_USART_TransmitterByteSend(USART_ID_6, chr); //Mobt@[1oCg݁EM   
    U6TXREG = chr;  ////Mobt@[1oCg݁EM

//    while (!PLIB_USART_TransmitterIsEmpty(USART_ID_6));  //Mobt@[ɂȂ܂ő҂
    while(!U6STAbits.TRMT);   //Mobt@[ɂȂ܂ő҂
}

void WriteString(const char *str)   //񑗐M֐    //RN4020p
{
    while(*str)
    {
        Write_Byte(*str);   //f[^M
        str++;
    }
}


void Write_Byte2(char chr)  //1oCgM֐   //Tera Term p
{
//    PLIB_USART_TransmitterByteSend(USART_ID_4, chr); //Mobt@[1oCg݁EM   
    U4TXREG = chr;  ////Mobt@[1oCg݁EM 

//  while (!PLIB_USART_TransmitterIsEmpty(USART_ID_4));  //Mobt@[ɂȂ܂ő҂
    while(!U4STAbits.TRMT);   //Mobt@[ɂȂ܂ő҂
}

void WriteString2(const char *str)   //񑗐M֐   //Tera Term p
{
    while(*str)
    {
        Write_Byte2(*str);   //f[^M
        str++;
    }
}


void display(void)  //LN^tւ̕\
{
    //tʃNA
    lcd_cmd(0x80);          //1ڂ̐擪
    sprintf(Buf,"                ");//
    lcd_str(Buf);                   //t\
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf,"                ");	//
    lcd_str(Buf);
                
    lcd_cmd(0x80);          //1ڂ̐擪
    sprintf(Buf,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c", Data[0],Data[1],Data[2],Data[3],Data[4],Data[5],Data[6],Data[7],Data[8],Data[9],Data[10],Data[11],Data[12],Data[13],Data[14],Data[15]);
    lcd_str(Buf);           // 1sڕ\
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",  Data[16],Data[17],Data[18],Data[19],Data[20],Data[21],Data[22],Data[23],Data[24],Data[25],Data[26],Data[27],Data[28],Data[29],Data[30],Data[31]);	//
    lcd_str(Buf);           // 2sڕ\
          
 //   delay_ms(100);    //Tera Term\݂̂̏ꍇ
    delay_ms(2000); //LN^t̕\𐸓ǂꍇ
}




void AdcFunc(void)          //ADϊA\
{
    unsigned int AdcValue;
    float Volt;
    char str0[] = "SHW,000E,12";    //peripheral LN^XeBbNւADϊl݃R}h
    char* strCmd;
    char numBuf[5]; 
    
    
    //ADϊJn Trigger a conversion 
    ADCCON3bits.GSWTRG = 1; //ADϊ\tgEFAgK //Global Level Software Trigger bit
    
    //ϊ҂ Wait the conversions to complete
    while (ADCDSTAT1bits.ARDY7 == 0);
           
    //ʂ̎o fetch the result
    AdcValue = ADCDATA7;
    
    if(abs(AdcValue - preAdcValue) > 125 )  //0.1v = 4095/3.3 = 124.091
                                            //ADϊl125傫ωꍇALN^XeBbN
                                            //@ZgNotification(m)    
    {
        Volt =(float)AdcValue/4095*3.3; //{g\
        sprintf(numBuf,"%04X",AdcValue);    //@@16i\
        
        strCmd = strcat(str0,numBuf);   //ԐMf[^쐬
        strCmd = strcat(strCmd,"\r");   //ԐMf[^̏I[\rǉ
        
        WriteString(strCmd);    //nh000EstrCmd  //
    
        preAdcValue = AdcValue;       //0.1v = 4095/3.3 = 124.091
    
        //I2C߁@LN^t\
        lcd_ACM1602_cmd_i2c(0x80);  //1sڂ̐擪
        sprintf(Buf,"AdV=%u           ",AdcValue); //obt@[ɕZbg
        lcd_ACM1602_str_i2c(Buf);
    
        lcd_ACM1602_cmd_i2c(0xC0);  //2sڂ̐擪
        sprintf(Buf,"Volt=%.2f[V]       ",Volt);       //Ƃăobt@[Ɏ[
        //sprintf(Buf,"%s", strCmd);       //Ƃăobt@[Ɏ[
        lcd_ACM1602_str_i2c(Buf);
        
        delay_ms(500);
     }
}

void AD_Initialize(void)    //AN10@ADϊ֘AWX^@
{
 // Configure ADCCON1 
    ADCCON1 = 0;    //
    ADCCON1bits.FRACT = 0; // use Integer output format
    ADCCON1bits.SELRES = 3; // ADC7 resolution is 12 bits   //default
    ADCCON1bits.STRGSRC = 0; // No scan trigger. 
 
    // Configure ADCCON2
    ADCCON2 = 0;
    ADCCON2bits.SAMC = 5; // ADC7 sampling time = 5 * TAD7
    ADCCON2bits.ADCDIV = 1; // ADC7 clock freq is half of control clock = TAD7

    // Configure ADCCON3
    ADCCON3 = 0;
    ADCCON3bits.ADCSEL = 0;     //NbN\[X:PBCLK3     // Select input clock source   
    ADCCON3bits.CONCLKDIV = 1;  // Control clock frequency is half of input clock
    ADCCON3bits.VREFSEL = 0;    // Select AVdd and AVss as reference source
    ADCCON3bits.DIGEN7 = 1;     //ADC7FL               //Shared ADC (ADC7) Digital Enable bit
    ADCCON3bits.RQCNVRT = 1;    //ʃ|[g̓[h      //Individual ADC Input Conversion Request bit
    
    ADCCON3bits.ADINSEL = 10;   //̓|[g AN10 ݒ    //Analog Input Select bits  //ύX_͂
  //  ADCCON3bits.ADINSEL = 8;   //̓|[g AN8 ݒ    //Analog Input Select bits
    ADCCON3bits.SAMP = 1;       //NX2[hݒ         //Class 2 and Class 3 Analog Input Sampling Enable bit

    // No selection for dedicated ADC modules, no pre sync trigger, not sync sampling 
    ADCTRGMODE = 0;

    // Select ADC input mode //ADC INPUT MODE CONTROL REGISTER 1
    ADCIMCON1bits.SIGN8 = 0; // unsigned data format
    ADCIMCON1bits.DIFF8 = 0; // Single ended mode

    ADCTRG2bits.TRGSRC7 = 1; //AN7\tgEFAgKɐݒ    //Trigger Source for Conversion of Analog Input AN7 Select bits //K{

    // Turn the ADC on 
    ADCCON1bits.ON = 1;

    // Enable clock to analog circuit 
    ADCANCONbits.ANEN7 = 1; // Enable the clock to analog bias

    // Wait for ADC to be ready
    while(!ADCANCONbits.WKRDY7); // Wait until ADC7 is ready

    // Enable the ADC module 
    ADCCON3bits.DIGEN7 = 1; // ADC7 ADCfW^HON
}

void StrInputRoutine(void)
{
    int i;
    int dx; //ASCIIl
    char* strAnswer;  //ԐMւ̃|C^@for char
 
     char str02[] = "SHW,000E,13";    //Nof L
    char* strCmd;
    char Data2[32]; //2oCg獇@@1
    char buf[5][8];
    char *endptr;
    char tempStr[2];
    int strLength1;
    int strLength2;
    
    i = 8;  //Data[8]炪f[^Af[^Ȃ̂ŏI[\0oɂ蕶񒷂o      
    do{
        if(Data[i] == '\0')
        {
            strLength1 = i;
            break;
        }
        i++;
    }while(i != 128);
    
   //16i\ WiASCII)ɕϊ    
    for( i  = 0; i < strLength1; i++)
    {
        sprintf(tempStr,"%c%c",Data[i*2 + 8],Data[i*2 + 9]);// tempStr = "4A"   //J
        dx = strtol(tempStr, &endptr, 16);  //16i@@10iԊ
        sprintf(&Data2[i],"%c",dx);     //10i@@ASCIIɕϊ
    }
    
    Data2[i + 1] = '\0';    //Data2[]
     
    lcd_cmd(0x80);          //1ڂ̐擪
    sprintf(Buf,"%s                 ",Data2);
    lcd_str(Buf); 
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf," strLength=%d                        ",strLength1);// 
    lcd_str(Buf);
    

  
    //  s
    if(strcmp(Data2,Japan) == 0) strAnswer = Tokyo;     //Japan̏ꍇ@@Tokyo
    else if(strcmp(Data2,America) == 0) strAnswer = Washington;   //Americȁꍇ@@Washinton
    else if(strcmp(Data2,UK) == 0) strAnswer = London;       // U.K.̏ꍇ@@London
    else if(strcmp(Data2,France) == 0) strAnswer = Paris;    //Francȅꍇ@@Paris
    else strAnswer = Pardon;                             //̑̏ꍇ@@Pardon ?
    
    
    strLength2 = strlen(strAnswer);   //񒷂擾
    //W16i\ɕϊ
    for(i = 0; i < strLength2; i++)
    {
        sprintf(buf[i],"%X",strAnswer[i]);  
        strcat(str02,buf[i]);
    }
 
    strCmd = strcat(str02,"\r");
    
    WriteString(strCmd);    //nh000EstrCmd  //
    
  
 
}


void Hnadle_BtInput(void)   //BTiPC)̓͏
{
    if(Flag_centData == 1)  //Zg̃f[^L
    {
        Flag_centData = 0;
                
        //tʃNA
        lcd_cmd(0x80);          //1ڂ̐擪
        sprintf(Buf,"                ");//
        lcd_str(Buf);                   //t\
        lcd_cmd(0xC0);          //Qsڂ̐擪
        sprintf(Buf,"                ");	//
        lcd_str(Buf);
    
        //tʃNA
        lcd_cmd(0x80);          //1ڂ̐擪
        sprintf(Buf,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",Data[0],Data[1],Data[2],Data[3],Data[4],Data[5],Data[6],Data[7],
                 Data[8],Data[9],Data[10],Data[11],Data[12],Data[13],Data[14],Data[15],Data[16],Data[17],Data[18],Data[19],Data[20],Data[21],Data[22]);//
        lcd_str(Buf);                   //t\
        lcd_cmd(0xC0);          //Qsڂ̐擪
        sprintf(Buf,"                ");	//
        lcd_str(Buf);
        
        //LED@ON/OFF M̏ꍇ
        if( (Data[0] =='W') && 
            (Data[1] == 'V') && 
            (Data[2] == ',') &&
            (Data[3] == '0') &&
            (Data[4] == '0') &&
            (Data[5] == '0') &&
            (Data[6] == 'B') &&
            (Data[7] == ',')) 
        {
            if(Data[9] == '1') LATCbits.LATC15 = 1; //LED3_
            else LATCbits.LATC15 = 0; //LED3
        }
        
        
        //@M̏ꍇ
         if( (Data[0] =='W') && 
            (Data[1] == 'V') && 
            (Data[2] == ',') &&
            (Data[3] == '0') &&
            (Data[4] == '0') &&
            (Data[5] == '1') &&
            (Data[6] == '1') &&
            (Data[7] == ','))StrInputRoutine();
        
    }    
}


void ConnectBLE(void)   //BLEڑ
{   
    
    WriteString("+//Echo OnOff\r");  //GR[obNݒ   //
    display();
    
                                     
    if(strstr(&Data[0],"Echo Off") != '\0')     //Echo OffԐMĂꍇ
         WriteString("+//Echo OnOff\r");  //GR[obNݒ   //
    display();
        
    
    WriteString("SF,1//Initialize RN4020\r");   //Ho׃Zbg
    display();
    
    WriteString("SR,00000000//Set Peripheral Mode\r");    //ytF[hݒ
    display();
    
    WriteString("SN,PIC32MZ\r");  //foCX̐ݒ
    display();
 
      
    WriteString("SS,00000001//Set User Defined Private Service\r");//[U`̃vCx[gT[rX
    display();
    
    WriteString("PZ//Clear Private Service\r");//vCx[gT[rX
    display(); 

    WriteString("PS,11223344556677889900AABBCCDDEEFF //Set Private Service UUID\r");//vCx[gT[rXUUIDݒ
    display();
    
    //LN^XeBbÑf[^i0x14oCg = 20oCgjۑp     //Mf[^p@LED@ON/OFFM
    WriteString("PC,010203040506070809000A0B0C0D0E01,1A,14//Set Private Chara UUID, Read_ResWrite_Notify, 16byte\r");//vCx[gLN^XeBbNUUIDݒ
                                            //PCR}hFő10@atRN4020
    display();
    
     //LN^XeBbÑf[^i0x14oCg = 20oCgjۑp    //ԐMf[^p@SW ON/OFFԁAVR1@ADϒli16i\jAs
    
    WriteString("PC,010203040506070809000A0B0C0D0E02,1A,14//Set Private Chara UUID, Read_ResWrite_Notify, 16byte\r");//vCx[gLN^XeBbNUUIDݒ
                                            //PCR}hFő10@atRN4020
    display();
    
     //LN^XeBbÑf[^i0x14oCg = 20oCgjۑp    //Mf[^@
    WriteString("PC,010203040506070809000A0B0C0D0E03,1A,14//Set Private Chara UUID, Read_ResWrite_Notify, 16byte\r");//vCx[gLN^XeBbNUUIDݒ
                                            //PCR}hFő10@atRN4020
    display();
    
    //LN^XeBÑvpeBۑp
    WriteString("PC,010203040506070809000A0B0C0D0E05,06,02//Set Private Chara UUID, Read_noResWrite, 2byte\r"); //K{@for "Connected" o@//vCx[gLN^XeBbNUUIDݒ
    display();
    
        
    WriteString("R,1//RN4020 Reboot\r"); //RN4020u[g
 
   
                                 
     while(strstr(&Data[0],"CMD") == '\0')
    {
       LATCbits.LATC14 = 0;  //LED2 
    };  //"CMD"܂܂镶񂪕ԐMĂ܂ő҂
                                            //Lwhile(!...)gȂꍇ@   delay_ms(2000); //K{@̎ԂZƈȌ̃R}hł܂삵ȂR}hL
//    while(strstr("12CMD56","CMD") == '\0'){};  //while(0)ƂȂʉ߂ł
                                                //vs@"CMD" @"ABC": NULLstrstr()ԂAwhile(1)ƂȂʉ߂łȂ
    
    
    WriteString("+//Echo OnOff\r");  //GR[obNݒ   //
    display();

    WriteString("A//Advertize\r");  //Aho^CYJn//Aho^CYJn    //A,<C^[omsec>,<msec>
                                        //default :100msec  //A,0014 -->interval=20msec    //A,0032 --> interval 50msec //A --> 100msec
 
    display(); 
     
      while(strstr(&Data[0],"Connected") == '\0')
    {
         LATCbits.LATC14 = 1; //LED2
         LATCbits.LATC14 = 0; //LED2 
         //K{@ asm("NOP");ł̓_@@{}[vɐ䂪Ȃƃ_H   //LED2
    }; //ŌołB2019.8.3@19F18
                                                //"Connected"܂܂镶񂪕ԐMĂ܂ő҂
    display();
    
    WriteString("LS//List Server services\r");    //T[o[T[rXXg
    display(); 

    delay_ms(1000);
    //
    
}

void Handle_PicSw(void) //PIC32MZSW̏
{     
    if(Flag_Sw == 1)
    {
        if(PORTFbits.RF13 == 0) //SW1ON̏ꍇ
        { 
            WriteString("SHW,000E,1111\r");    //nh000E01  //
          //  WriteString("SHW,000E,11\r");    //nh000E01  //
            delay_ms(100);
            Flag_Sw = 0;
        }
    }
    
    if(Flag_Sw == 2)
    {
        Flag_Sw = 0;          
        if(PORTFbits.RF13 == 1) //SW1OFF̏ꍇ
        {
            WriteString("SHW,000E,1110\r");    //nh00EB10  //
            //WriteString("SHW,000E,10\r");    //nh00EB10  //
            delay_ms(100);
            Flag_Sw = 0;
        }
    }
}




/*******************************************************************************
  Function:
    void APP_Initialize ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Initialize ( void )
{
    /* Place the App state machine in its initial state. */
    appData.state = APP_STATE_INIT;

    
    /* TODO: Initialize your application's state machine and other
     * parameters.
     */
    
    AD_Initialize();    //AN10@ADϊ֘AWX^@
    
    
    LATBbits.LATB5 = 1; //1:CMD[h //R}h[hON    //0:MLDP[h  //CMD_MLDPs
    LATAbits.LATA5 = 1; //1: RN4020ANeBu  //WAKE_SW

     
    lcd_init();				// LCD
    lcd_cmd(0b00001100);    // J[\:OFF  uݸ:OFF
    lcd_clear(); 
    lcd_cmd(0x80);          //1ڂ̐擪
    sprintf(Buf,"BLE2 Click          ");//
    lcd_str(Buf);                   //t\
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf,"Now Running !!    ");	//
    lcd_str(Buf);           // JnbZ[W1sڕ\
    
    LATCbits.LATC15 = 0; //LED3 
    
    lcd_ACM1602_init_i2c();     //I2CC^[tF[Xt
    lcd_ACM1602_cmd_i2c(0x0C);    //J[\F0FFAuNF0FF
    
    lcd_ACM1602_cmd_i2c(0x80);  //1sڂ̐擪
    lcd_ACM1602_str_i2c("AD Convert");
    
    lcd_ACM1602_cmd_i2c(0xC0);  //2sڂ̐擪
    lcd_ACM1602_str_i2c("   AN10  VR1              ");   
    delay_ms(2000);     //@CMD@//PIC32MZւ̕ԐM
   
    ConnectBLE();  //BLEڑ
    
    

}


/******************************************************************************
  Function:
    void APP_Tasks ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Tasks ( void )
{

    /* Check the application's current state. */
    switch ( appData.state )
    {
        /* Application's initial state. */
        case APP_STATE_INIT:
        {
            bool appInitialized = true;
       
        
            if (appInitialized)
            {
                appData.state = APP_STATE_SERVICE_TASKS;
            }
            break;
        }

        case APP_STATE_SERVICE_TASKS:
        {
            Hnadle_BtInput();   //BTiPC)̓͏
            
            Handle_PicSw();     //PIC32MZSW̏

            AdcFunc();          //VR1 ADϊ
            break;
        }

        /* TODO: implement your application state machine.*/
        

        /* The default state should never be executed. */
        default:
        {
            /* TODO: Handle error in application's state machine. */
            break;
        }
    }
}

 

/*******************************************************************************
 End of File
 */
